// 
// Patron pour la generation d'une classe derivee dans ROOT
// FGanilDataReader derive de FDataReader
// 
 
#ifndef FGanilDataReader_h 
#define FGanilDataReader_h 
 
#include "FDataReader.h" 
#include "FParamBrut.h" 
#include "GDevice.h" 
#include "GAcq.h" 
 
class FGanilDataReader : public FDataReader { 
 
   protected:
	Bool_t	nextBuf;
	FParamBrut  **arrayOfParams; //!
	Int_t  nbOfParamsBruts;
	Int_t  nbloc;
	Long_t  nevt;
	TString experiment;
	GAcq	*acq;
	GDevice *GRUdevice;
	
	Bool_t stop;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FGanilDataReader(void);    // constructeur par defaut 
	FGanilDataReader(const FGanilDataReader &ap); // constructeur par copie 
	
	~FGanilDataReader(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FGanilDataReader& operator = (const FGanilDataReader &hp); // operateur = 
 
	virtual void InitListOfParamsBruts(void);
	virtual void SetParamBrutsValues(void);
	virtual Bool_t IsOk(void);
	virtual FParamBrut *GetParamBrut(Int_t label);
	virtual void SetExperiment(Char_t *expe) {experiment=expe;}
	virtual GAcq* GetGAcq(void) {return acq;}
	virtual void SetDevice(FDevice *dev=0);

	virtual void InitFromEnv(TEnv *env);

    ClassDef(FGanilDataReader,1)
 
}; 
 
#endif 
 
