// 
// Patron pour la generation d'une classe derivee dans ROOT
// FIbisDataReader derive de FBlockDataReader
// 
 
#ifndef FIbisDataReader_h 
#define FIbisDataReader_h 

#include "FBlockDataReader.h" 
#include "FParamBrut.h" 

//#define IBIS_EVENT_FROM_NARVAL
 
class FIbisDataReader : public FBlockDataReader { 
 
   protected: 
        virtual void Init(void);       // initialisation 
	virtual Int_t GetNextEvent(void);
	virtual void GetCard(void);
	virtual void GetCardMS(void);
	virtual void GetCardMI(void);
	virtual void GetCardMX(UShort_t numCard);
 
   public:	 
   	FIbisDataReader(void);    // constructeur par defaut 
	FIbisDataReader(const FIbisDataReader &ap); // constructeur par copie 
	
	~FIbisDataReader(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FIbisDataReader& operator = (const FIbisDataReader &hp); // operateur = 
 
	virtual void InitListOfParamsBruts(void);

    ClassDef(FIbisDataReader,1)
 
}; 
 
#endif 
 
