// 
// Patron pour la generation d'une classe derivee dans ROOT
// FGRUNetSpy derive de FDevice
// 
 
#ifndef FGRUNetSpy_h 
#define FGRUNetSpy_h 
 
#include "FGRUDevice.h" 
#include "TString.h" 
 
class FGRUNetSpy : public FGRUDevice { 
 
   protected:
   	TString interface;
   	TString server;
   	TString destination;
   	TString header;
   	TString experiment;
   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FGRUNetSpy(void);    // constructeur par defaut 
	FGRUNetSpy(const FGRUNetSpy &ap); // constructeur par copie 
	
	~FGRUNetSpy(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FGRUNetSpy& operator = (const FGRUNetSpy &hp); // operateur = 
 
	virtual void SetInterface(const Char_t *fn=0);
	virtual const Char_t *GetInterface(void){return interface.Data();}
	virtual void SetServer(const Char_t *fn=0);
	virtual const Char_t *GetServer(void){return server.Data();}
	virtual void SetDestination(const Char_t *fn=0);
	virtual const Char_t *GetDestination(void){return destination.Data();}
	virtual void SetHeader(const Char_t *fn=0);
	virtual const Char_t *GetHeader(void){return header.Data();}

	virtual void Open(void);

	virtual void InitFromEnv(TEnv *env);
	virtual GDevice *GetGRUDevice(void);
 
     ClassDef(FGRUNetSpy,1)
 
}; 
 
#endif 
 
