// 
// Patron pour la generation d'une classe derivee dans ROOT
// FCounter derive de FParam
// 
 
#ifndef FCounter_h 
#define FCounter_h 
 
#include "FRateCounter.h" 
 
class FCounter : public FRateCounter { 
 
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FCounter(void);    // constructeur par defaut 
	FCounter(const FCounter &ap); // constructeur par copie 
	
	~FCounter(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FCounter& operator = (const FCounter &hp); // operateur = 
 
 	virtual void    Reset(void){SetOn();}
 	virtual Double_t GetValue(Int_t i=0) const {return counts;}

 	virtual void    WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin,TList *lop);

	virtual void 	IncrementCounter(void);

    ClassDef(FCounter,1)
 
}; 
 
#endif 
 
