// 
// Patron pour la generation d'une classe derivee dans ROOT
// FGRUFile derive de FDevice
// 
 
#ifndef FGRUFile_h 
#define FGRUFile_h 
 
#include "FGRUDevice.h" 
#include "TString.h" 
 
class FGRUFile : public FGRUDevice { 
 
   protected:
   	TString fileName;
   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FGRUFile(void);    // constructeur par defaut 
	FGRUFile(const FGRUFile &ap); // constructeur par copie 
	
	~FGRUFile(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FGRUFile& operator = (const FGRUFile &hp); // operateur = 
 
	virtual void SetFileName(const Char_t *fn=0);
	virtual const Char_t *GetFileName(void){return fileName.Data();}

	virtual GDevice *GetGRUDevice(void);
	virtual void InitFromEnv(TEnv *env);
 
     ClassDef(FGRUFile,1)
 
}; 
 
#endif 
 
