//
// Classe de base pour les connections reseau en IP
// D.Etasse, D.Cussol : 16/06/2006
//

#ifndef FIPConnection_h
#define FIPConnection_h

#ifndef __CINT__
#include <sys/types.h>
#include "Riostream.h"
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <string.h>
#endif

#include "TObject.h"

class FIPConnection : public TObject {
 protected:
   struct sockaddr_in	sock; //!
   Int_t		s;    //!
   Bool_t		do_swap; //!
   
 private:
   void Init(void);
 
 public:
   FIPConnection(void); 		     // constructeur par default
   FIPConnection(const FIPConnection& conn); // constructeur par copie
   virtual void Copy(TObject& c) const; // copie
   FIPConnection& operator=(const FIPConnection& conn); // operateur =
   virtual ~FIPConnection(void); 		     // destructeur
 
   virtual void  Open( Int_t port, Char_t *ipaddress=0)=0;
   virtual Int_t Close(void);
   virtual Int_t ReadBuf(UChar_t *buf,Int_t bufLen)=0;
   virtual Int_t WriteBuf(UChar_t *buf,Int_t bufLen)=0;
   virtual void  SetSwap(Bool_t s=kTRUE){do_swap=s;}
   virtual Bool_t GetSwap(void){return do_swap;}
   virtual void  Swap(UChar_t *buf, Int_t size);
   
   ClassDef(FIPConnection,1) // Base class for IP Connection
 
 };
#endif
