#ifndef FLightGUI_h
#define FLightGUI_h

#include "TSystem.h"
#include "TGFrame.h"
#include "TGButton.h"
#include "TGaxis.h"
#include "TFile.h"
#include "TFormula.h"
#include "TKey.h"
#include "TGComboBox.h"
#include "TRootEmbeddedCanvas.h"
#include "TGLayout.h"
#include "TF1.h"
#include "TMath.h"
#include "TCanvas.h"
#include "TGTextEntry.h"
#include "TGDoubleSlider.h"
#include <TQObject.h>
#include <RQ_OBJECT.h> 
#include <TApplication.h>
#include <TGClient.h>
#include <TCanvas.h>
#include <TH1.h>
#include <TROOT.h>
#include <TClass.h>
#include <TRandom.h>
#include <TGButton.h>
#include <TArrow.h>
#include <TGStatusBar.h>
#include <TRootEmbeddedCanvas.h>
#include <TGLabel.h>
#include <TString.h>
#include <TText.h>
#include <TStyle.h>
#include <TGraph.h>
#include <Rtypes.h>
#include <TGFileDialog.h>
#include <TGMsgBox.h>
#include <TGNumberEntry.h>
#include <TGListBox.h>
#include <TExec.h>
#include <TPluginManager.h>
#include <vector>
#include <TPaveStats.h>
#include "FEventProcessorThread.h"
#include "TTimer.h"
#include "MTNELabel.h"

class FLightGUI : public TGMainFrame {

  enum ElementId
  {
    TE_TimerLabel,
  };
private:
 TRootEmbeddedCanvas *fCanvas;
 TGLayoutHints       *fLcan;
 TGLayoutHints       *fBly, *fBfly1, *fBfly2, *fBfly3;
 TGDoubleHSlider     *fHSlider1;
 TGPictureButton     *fOpenFileButton, *fExit, *fUnZoom, *fPrint, *fSaveHisto;
 TGPictureButton     *fFitGausButton,  *fFitButton, *fCalButton, *fCalResetButton;
 TGCheckButton       *fLog, *fGaus;
 TGComboBox          *fListOfHistos;
 TFile               *fFile;
 TGStatusBar         *fStatusBar;
 TGLabel             *fPointedValue;
 Int_t               fNPoints;
 TGListBox           *fListPoints;
 TGCompositeFrame *fMainFrame2091, *fMainFrame989; 
 Bool_t kFitGausHisto;
 TGraph *fCalGraph;
 TCanvas *cMainCanvas;
 static TH1F *gHisto; 
 static TF1 *gCalFct; 
 TList *fSelected ;  
//TGNumberEntry **fNrjVal ;
//std::vector<TGNumberEntry *>fNrjVal ;
 static TList *fNrjVal;
 TCanvas *cFitCanvas;
 TGPictureButton *fStartFitP1;
 TGPictureButton *fStartFitP2;
 TGLabel **fPts,*fResults,*fChiNDF;
 TRootEmbeddedCanvas *fPlotFitRes;
 TGPictureButton *fExitCalWin;
 TGaxis *AxisCal;
 UInt_t nsel;
 TGTransientFrame *fCalWin;
 FEventProcessorThread *fept;
 TGPictureButton       *bRun, *bPause, *bStop, *bClearSpectra;
 TGLabel	       *runStatus;
 TTimer		*displayRefresh;
 TTimer		*runTimer;
 MTNELabel	*acqTimer;

public:
 FLightGUI(const TGWindow *p=0,UInt_t w=1200,UInt_t h=800,TString fname="");
 ~FLightGUI();

 void CloseWindow();
 void DoSlider();
 void SelectKey(Int_t);
 void SelectPixel(Int_t,Int_t,Int_t,TObject*);
 void LogLinScale();
 void UnZoom();
 void PrintHisto();
 void SaveHisto();
 void FitGausHisto(Double_t,Double_t);
 void FitGausHisto();
 void FitHisto();
 void CloseCalWindow();
 void ProcessCal(Int_t);
 void ProcessCal1(){ProcessCal(1);};
 void ProcessCal2(){ProcessCal(2);};
 void CalWindow();
 void GausFitPeak();
 UInt_t ListHisto();
 void OpenFile();
 void CalHisto();
 void ResetCalibration();
 void AddPointToList(Double_t,Double_t,Double_t,Bool_t);
 static void DrawAxisCal();
 virtual void SetFEventProcessorThread(FEventProcessorThread *f) { fept=f;};
 virtual void StartProcessing(void);
 virtual void PauseProcessing(void);
 virtual void StopProcessing(void);
 virtual void ClearSpectra(void);
 virtual Bool_t HandleTimer(TTimer *timer);
 virtual void RefreshEmbeddedCanvas(void);
  
ClassDef(FLightGUI, 0)
};

#endif
