// 
// Patron pour la generation d'une classe derivee dans ROOT
// FTimeHistAtt derive de FH1Att
// 
 
#ifndef FTimeHistAtt_h 
#define FTimeHistAtt_h 
 
#include "FH1Att.h" 
//#include "TStopwatch.h" 
#include "TDatime.h" 
 
class FTimeHistAtt : public FH1Att { 
 
   protected:
//   	TStopwatch *stopwatch;
   	TDatime    *datime;
   	UInt_t     startTime;
	Double_t   timestep;
	Double_t   timemin;
	Double_t   timemax;
   
   protected: 
        virtual void Init(void);       // initialisation 
 	virtual void ShiftHisto(Double_t time);
 	virtual void DoShift(Int_t ishift);
	virtual void FillTimeHist(Double_t time, FParam *p, Stat_t w=1.);

   public:	 
   	FTimeHistAtt(void);    // constructeur par defaut 
	FTimeHistAtt(const FTimeHistAtt &ap); // constructeur par copie 
	
	~FTimeHistAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FTimeHistAtt& operator = (const FTimeHistAtt &hp); // operateur = 
 
	virtual void SetParamX(FParam *p);
	virtual void SetTimeStep(Double_t t=1.);
	virtual void SetStartTime(void);
	virtual Double_t GetTimeMin(void) const{return timemin;}
	virtual Double_t GetTimeMax(void) const{return timemin;}
	virtual Double_t GetTimeStep(void) const{return timestep;}
	
	virtual void FillHist(Stat_t w=1.);

	
 	virtual void WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);
	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);

    ClassDef(FTimeHistAtt,1)
 
}; 
 
#endif 
 
