// 
// Patron pour la generation d'une classe derivee dans ROOT
// FWindowHistAtt derive de FH1Att
// 
 
#ifndef FWindowHistAtt_h 
#define FWindowHistAtt_h 
 
#include "FH2Att.h" 
#include "FParam.h" 

class FWindowHistAtt : public FH2Att { 
 
   protected:
	Double_t   stepVal;
	Double_t   minVal;
	Double_t   maxVal;
	Long64_t   nFill;
   
   protected: 
        virtual void Init(void);       // initialisation 
 	virtual void ShiftHisto(Double_t val);
 	virtual void DoShift(Int_t ishift);

   public:	 
   	FWindowHistAtt(void);    // constructeur par defaut 
	FWindowHistAtt(const FWindowHistAtt &ap); // constructeur par copie 
	
	~FWindowHistAtt(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void CopyHistAtt(FHistAtt & obj) const;
#else
   	virtual void CopyHistAtt(FHistAtt & obj);
#endif
	FWindowHistAtt& operator = (const FWindowHistAtt &hp); // operateur = 
 
	virtual void SetStepValue(Double_t t=1.);
	virtual void SetStartValue(Double_t v=0.);
	virtual Double_t GetMinValue(void) const{return minVal;}
	virtual Double_t GetMaxValue(void) const{return minVal;}
	virtual Double_t GetStepValue(void) const{return stepVal;}
	
	virtual void FillHist(Stat_t w=1.);

	
 	virtual void WriteInFile(ofstream &fout);
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);
	virtual TList *GenericBuilding(TList *lop=0,TList *los=0,
				      FGenericName *name=0,
				      FGenericName *title=0,
				      FGenericName *paramX=0,
				      Int_t nx=0,Double_t xmin=0.,Double_t xmax=0.,
				      FGenericName *paramY=0,
				      Int_t ny=0,Double_t ymin=0.,Double_t ymax=0.,
				      FGenericName *cond=0);

   	virtual void ResetToInit(Option_t *option="");

    ClassDef(FWindowHistAtt,1)
 
}; 
 
#endif 
 
