//
// Canvas avec les reperes
//

#ifndef MCanvasWithMark_h
#define MCanvasWithMark_h

#include "MLineMark.h"
#include "TLatex.h"
#include "TLegend.h"
#include "TLegendEntry.h"
#include "TCanvas.h"

class MCanvasWithMarks: public TCanvas
{

 protected:
   TLatex ldx;
   TLatex ldy;
   MLineMark lmh1;
   MLineMark lmh2;
   MLineMark lmv1;
   MLineMark lmv2;
   
   Bool_t   mvOn;
   Bool_t   mhOn;
   
   TLegend       legend;
   TLegendEntry  leXmin;
   TLegendEntry  leXmax;
   TLegendEntry  leDX;
   TLegendEntry  leYmin;
   TLegendEntry  leYmax;
   TLegendEntry  leDY;
   
   virtual void Init(void);
   
 public:
   MCanvasWithMarks(const char* name = "c1wm", const char *title="Canvas With Marks", Int_t form=1);
   MCanvasWithMarks(const char* name, Int_t ww, Int_t wh, Int_t winid);
   ~MCanvasWithMarks(void);

   virtual void VerticalMarks(Int_t val=1); // *TOGGLE* *GETTER=IsVerticalActivated
   virtual void HorizontalMarks(Int_t val=1); // *TOGGLE* *GETTER=IsHorizontalActivated
   virtual void ActivateHorizontalMarks(void);
   virtual void ActivateVerticalMarks(void);
   virtual void DeactivateHorizontalMarks(void);
   virtual void DeactivateVerticalMarks(void);
   virtual void UpdateVisu(void);
   virtual void UpdateMarks(void);
   virtual Bool_t IsVerticalActivated(void) {return mvOn;}
   virtual Bool_t IsHorizontalActivated(void) {return mhOn;}
   virtual Double_t GetXmin(void) {return lmv1.GetX1();}
   virtual Double_t GetXmax(void) {return lmv2.GetX1();}
   virtual Double_t GetYmin(void) {return lmh1.GetX1();}
   virtual Double_t GetYmax(void) {return lmh2.GetX1();}


ClassDef(MCanvasWithMarks,1)
};

#endif
