// 
// Patron pour la generation d'une classe derivee dans ROOT
// MFCondManager derive de MFPCManager
// 
 
#ifndef MFCondManager_h 
#define MFCondManager_h 
 
#include "MFPCManager.h" 
#include "TCutG.h" 
 
class MFCondManager : public MFPCManager { 
 
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	MFCondManager(const TGWindow *p=0,UInt_t w=200,UInt_t h=200);    // constructeur par defaut 
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MFCondManager(const MFCondManager &ap); // constructeur par copie 
#endif	
	~MFCondManager(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MFCondManager& operator = (const MFCondManager &hp); // operateur = 
 
	virtual void BuildListeParCal(void);
	virtual FParamCalc *AddParCal(void);
	virtual void RemoveParCal(void);
	virtual void NewCond(char* s) {Emit("NewCond(char*)",s);} // *SIGNAL*
	virtual void RemCond(char* s) {Emit("RemCond(char*)",s);} // *SIGNAL*
	virtual TCutG *GetTCutG(Char_t *nom);

    ClassDef(MFCondManager,1)
 
}; 
 
#endif 
 
