// 
// Patron pour la generation d'une classe derivee dans ROOT
// MHistogramBuilderGUI derive de TGCompositeFrame
// 
 
#ifndef MHistogramBuilderGUI_h 
#define MHistogramBuilderGUI_h 
 
#include "TROOT.h"
#include "TGClient.h"
#include "FEventProcessor.h" 
#include "MCBLabel.h" 
#include "MTELabel.h" 
 
class MHistogramBuilderGUI : public TGCompositeFrame { 

	enum ElementId 
	{
	 CB_loDR,
	 CB_loDev,
	};
 
   protected: 
	FEventProcessor		*fept;
	TList			*listOfGUIClasses;
	MCBLabel		*loHistosClasses;
	TGCompositeFrame	*histoGUI;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	MHistogramBuilderGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MHistogramBuilderGUI(const MHistogramBuilderGUI &ap); // constructeur par copie 
#endif
	
	~MHistogramBuilderGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MHistogramBuilderGUI& operator = (const MHistogramBuilderGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual FEventProcessor *GetFEventProcessor(void)
		{return fept;}
	virtual void SetFEventProcessor(FEventProcessor *f=0)
		{fept=f;}
		
	virtual void BuildlistOfGUIClasses();
	virtual void SelectHistoClass(Int_t sel);
        virtual TGCompositeFrame *GetGUI(Char_t *guiName);
	virtual void ShowHistoGUI(TGCompositeFrame *cf);
	
	// Signals
	virtual void HistoCreated(Char_t *hname) 
	   {Emit("HistoCreated(Char_t *)",hname);} // *SIGNAL*

	virtual void Reset(void);
	virtual void WarningBox(char const *title="Warning",char const *msg="Warning");

    ClassDef(MHistogramBuilderGUI,1)
 
}; 
 
#endif 
 
