// 
// Patron pour la generation d'une classe derivee dans ROOT
// MIPDeviceGUI derive de MDeviceGUI
// 
 
#ifndef MIPDeviceGUI_h 
#define MIPDeviceGUI_h 
 
#include "MDeviceGUI.h"
#include "MTELabel.h"
#include "MCBLabel.h"
 
class MIPDeviceGUI : public MDeviceGUI { 

   protected:
   	MTELabel *serverName;
   	MTELabel *port;
   	MCBLabel *protocol;
	TGCheckButton *swap;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	MIPDeviceGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MIPDeviceGUI(const MIPDeviceGUI &ap); // constructeur par copie 
#endif
	
	~MIPDeviceGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MIPDeviceGUI& operator = (const MIPDeviceGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual void SetDeviceProperties(void);
	virtual void ReadDeviceProperties(void);

	virtual void Reset(void);

    ClassDef(MIPDeviceGUI,1)
 
}; 
 
#endif 
 
