// 
// Patron pour la generation d'une classe derivee dans ROOT
// MTreeDeviceGUI derive de MDeviceGUI
// 
 
#ifndef MTreeDeviceGUI_h 
#define MTreeDeviceGUI_h 
 
#include "MDeviceGUI.h"
#include "MTELabel.h"
#include "MCBLabel.h"
 
class MTreeDeviceGUI : public MDeviceGUI { 

   protected:
   	MTELabel *fileName;
   	MTELabel *treeName;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
	MTreeDeviceGUI(const TGWindow *p=0,UInt_t w=500,UInt_t h=300);
#if ROOT_VERSION_CODE <= ROOT_VERSION(5,12,0)
	MTreeDeviceGUI(const MTreeDeviceGUI &ap); // constructeur par copie 
#endif
	
	~MTreeDeviceGUI(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	MTreeDeviceGUI& operator = (const MTreeDeviceGUI &hp); // operateur = 
 
	virtual Bool_t ProcessMessage(Long_t msg, Long_t par1, Long_t par2); 

	virtual void SetDeviceProperties(void);
	virtual void ReadDeviceProperties(void);
	virtual void OpenDevice(void);

	virtual void Reset(void);
	
	virtual void TreeChanged(void) {Emit("TreeChanged()");} // *SIGNAL*

    ClassDef(MTreeDeviceGUI,1)
 
}; 
 
#endif 
 
