// 
// Patron pour la generation d'une classe derivee dans ROOT
// FParamLastValue derive de FParam
// 
 
#ifndef FParamLastValue_h 
#define FParamLastValue_h 
 
#include "FParam.h" 
#include "FCondition.h" 
 
class FParamLastValue : public FParam { 
 
   protected: 
        Double_t valeur; // initialisation
	FParam   *param; // parametre dont on veut la derniere valeur 
	FCondition   *condition; // condition pour ajuster la valeur

   protected: 
        virtual void Init(void); // initialisation 
 
   public:	 
   	FParamLastValue(void); // constructeur par defaut 
	FParamLastValue(const FParamLastValue &ap); // constructeur par copie 
	
	~FParamLastValue(void); // desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FParamLastValue& operator = (const FParamLastValue &hp); // operateur = 
 
	virtual void     Reset(){;} // On ne resette pas une valeur de reference en temps utilisee pour l'ecploitation d'un parametre calcule en temps !
	virtual Bool_t 	IsOn(void) const;
	virtual void  	 SetValue(Double_t val,Int_t i=0);
 	virtual Double_t GetValue(Int_t i=0) const {return valeur;}
 	virtual Bool_t  ReadInFile(ifstream &fin,TList *lop);
	virtual void	SetParam(FParam *p=0);
	virtual FParam *GetParam(void){return param;}
	virtual void SetCondition(FCondition *c=0);
 	virtual FCondition *GetCondition() {return condition;}

    ClassDef(FParamLastValue,1)
}; 
#endif 
 
