// 
// Patron pour la generation d'une classe derivee dans ROOT
// FParamTime derive de FParam
// 
 
#ifndef FParamTime_h 
#define FParamTime_h 
 
#include "FParam.h"
#include "TTimeStamp.h" 
 
class FParamTime : public FParam { 
 
   protected:
   	TTimeStamp  timeStamp;
   
   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	FParamTime(void);    // constructeur par defaut 
	FParamTime(const FParamTime &ap); // constructeur par copie 
	
	~FParamTime(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	FParamTime& operator = (const FParamTime &hp); // operateur = 
 
 	virtual Double_t GetValue(Int_t i=0) const 
	       {TTimeStamp *ts=(TTimeStamp *)&timeStamp;ts->Set(); return timeStamp.AsDouble();}
	virtual void    SetValue(Double_t val, Int_t i=0) {;}
	virtual Bool_t 	IsOn(void) const {return kTRUE;}
 	virtual Bool_t  ReadInFile(ifstream &fin, TList *lop);

    ClassDef(FParamTime,1)
 
}; 
 
#endif 
 
