// 
// Patron pour la generation d'une classe derivee dans ROOT
// Correl3 derive de TNamed
// 
 
#ifndef Correl3_h 
#define Correl3_h 
 
#include "FEventProcessorThread.h" 
#include "FH2F.h" 
#include "FH1F.h" 
#include "TTimeStamp.h" 
#include "TGraph.h" 
#include "TList.h" 
#include "TBenchmark.h" 
#include "TEnv.h" 
#include <queue>
#include <vector>
 
class Correl3 : public FEventProcessorThread { 
 
   protected:
	// Axes du bidim
        vector<FParam *> nbOutX;
        vector<FParam *> nbOutZ;
	// Parametres de validation
        FParam *validDelay;
        FParam *validGate;
        FParam *scanGate;

	TList dataMerger; // Liste des DataMerger's

        TBenchmark bench;
	
	TEnv    env;
	Bool_t  thickOnly;
	Bool_t  trigRHB;
	
	Double_t TSThick4,TSThin4,TSCsI4;

   protected: 
        virtual void Init(void);       // initialisation 
 
   public:	 
   	Correl3(void);    // constructeur par defaut 
	Correl3(const Correl3 &ap); // constructeur par copie 
	
	~Correl3(void);		// desctructeur; 
	 
#if ROOT_VERSION_CODE >= ROOT_VERSION(3,4,0)
   	virtual void Copy(TObject & obj) const;
#else
   	virtual void Copy(TObject & obj);
#endif
	Correl3& operator = (const Correl3 &hp); // operateur = 

	virtual void InitParams(void);
	virtual void InitHistos(void);
	virtual void SetParamValues(void);
	//virtual Bool_t IsRunning(void);
	virtual void SaveHistos(void);
	//virtual Bool_t DoPlotTempo(void);
	//virtual void PlotTempo(void);
 
    ClassDef(Correl3,1)
 
}; 
 
#endif 
 
